package dev.shadowsoffire.apotheosis.spawn.modifiers;

package .var.folders._j.vfbv187d0bb8b8w5spzgg8180000gn.T;

import dev.shadowsoffire.apotheosis.spawn.modifiers.SpawnerStat;
import dev.shadowsoffire.apotheosis.spawn.spawner.ApothSpawnerTile;
import java.util.LinkedHashMap;
import java.util.Map;
import java.util.function.Consumer;
import net.minecraft.network.chat.Component;

public class SpawnerStats {
  public static final Map<String, SpawnerStat<?>> REGISTRY = new LinkedHashMap<>();
  
  public static final SpawnerStat<Short> MIN_DELAY;
  
  public static final SpawnerStat<Short> MAX_DELAY;
  
  public static final SpawnerStat<Short> SPAWN_COUNT;
  
  public static final SpawnerStat<Short> MAX_NEARBY_ENTITIES;
  
  public static final SpawnerStat<Short> REQ_PLAYER_RANGE;
  
  public static final SpawnerStat<Short> SPAWN_RANGE;
  
  public static final SpawnerStat<Boolean> IGNORE_PLAYERS;
  
  public static final SpawnerStat<Boolean> IGNORE_CONDITIONS;
  
  public static final SpawnerStat<Boolean> REDSTONE_CONTROL;
  
  public static final SpawnerStat<Boolean> IGNORE_LIGHT;
  
  public static final SpawnerStat<Boolean> NO_AI;
  
  public static final SpawnerStat<Boolean> SILENT;
  
  public static final SpawnerStat<Boolean> BABY;
  
  static {
    MIN_DELAY = register(new ShortStat("min_delay", s -> Integer.valueOf(s.f_59788_.f_45447_), (s, v) -> s.f_59788_.f_45447_ = v.shortValue()));
    MAX_DELAY = register(new ShortStat("max_delay", s -> Integer.valueOf(s.f_59788_.f_45448_), (s, v) -> s.f_59788_.f_45448_ = v.shortValue()));
    SPAWN_COUNT = register(new ShortStat("spawn_count", s -> Integer.valueOf(s.f_59788_.f_45449_), (s, v) -> s.f_59788_.f_45449_ = v.shortValue()));
    MAX_NEARBY_ENTITIES = register(new ShortStat("max_nearby_entities", s -> Integer.valueOf(s.f_59788_.f_45451_), (s, v) -> s.f_59788_.f_45451_ = v.shortValue()));
    REQ_PLAYER_RANGE = register(new ShortStat("req_player_range", s -> Integer.valueOf(s.f_59788_.f_45452_), (s, v) -> s.f_59788_.f_45452_ = v.shortValue()));
    SPAWN_RANGE = register(new ShortStat("spawn_range", s -> Integer.valueOf(s.f_59788_.f_45453_), (s, v) -> s.f_59788_.f_45453_ = v.shortValue()));
    IGNORE_PLAYERS = register(new BoolStat("ignore_players", s -> Boolean.valueOf(s.ignoresPlayers), (s, v) -> s.ignoresPlayers = v.booleanValue()));
    IGNORE_CONDITIONS = register(new BoolStat("ignore_conditions", s -> Boolean.valueOf(s.ignoresConditions), (s, v) -> s.ignoresConditions = v.booleanValue()));
    REDSTONE_CONTROL = register(new BoolStat("redstone_control", s -> Boolean.valueOf(s.redstoneControl), (s, v) -> s.redstoneControl = v.booleanValue()));
    IGNORE_LIGHT = register(new BoolStat("ignore_light", s -> Boolean.valueOf(s.ignoresLight), (s, v) -> s.ignoresLight = v.booleanValue()));
    NO_AI = register(new BoolStat("no_ai", s -> Boolean.valueOf(s.hasNoAI), (s, v) -> s.hasNoAI = v.booleanValue()));
    SILENT = register(new BoolStat("silent", s -> Boolean.valueOf(s.silent), (s, v) -> s.silent = v.booleanValue()));
    BABY = register(new BoolStat("baby", s -> Boolean.valueOf(s.baby), (s, v) -> s.baby = v.booleanValue()));
  }
  
  public static void generateTooltip(ApothSpawnerTile tile, Consumer<Component> list) {
    for (SpawnerStat<?> stat : REGISTRY.values()) {
      Component comp = stat.getTooltip(tile);
      if (!comp.getString().isEmpty())
        list.accept(comp); 
    } 
  }
  
  private static <T extends SpawnerStat<?>> T register(T t) {
    REGISTRY.put(t.getId(), (SpawnerStat<?>)t);
    return t;
  }
}
